###### 1. Muzzle Velocity #######
# We want to know the initial speed at which a High
# Explosive shell fires from a 105mm Howitzer. We know
# it in feet per second, but need it in meters per second.

v_i_feet_per_second = 875  # ft/s
meters_per_foot = 0.3048  # m/ft

# convert the value (multiply)
v_i = v_i_feet_per_second * meters_per_foot

# print it out to check!
print("v_i:", v_i)

###### 2. Forward-facing Area #######
# We want to know the cross-sectional area of the High
# Explosive shell as it flies through the air. We
# know the diameter, and need to caluclate the area.

diameter = 0.105  # the diameter of the shell (in meters)
pi = 3.1415926536  # the value of pi

# use the area formula to calculate
area = pi * (diameter / 2)**2

# print it out to check!
print("A:", area)

###### 3. Terminal Velocity #######
# We want to know the terminal velocity of the High
# Explosive shell as it flies through the air. We
# know the parameters, and need to caluclate it.

# a = computed earlier
mass = 13.19  # the weight of the shell (in kilograms, from product specifications)
C_d = 0.0494  # the coefficient that modifies drag for an aerodynamic shape (from experimental tests)
rho = 1.225  # the density of air at sea level and 15 degrees C (in kg/m^3)
g = 9.8  # the acceleration of gravity (in m/s^2)

# use the terminal velocity formula to calculate
from math import sqrt  # << this imports the square root function from Python's math library

# example usage:
# >>> sqrt(4)
# 2

v_t = sqrt((2 * mass * g)/(rho * area * C_d))

# print it out to check!
print("v_t:", v_t)

####### 4. Ballistic trajectory #######
# We want to give the program a time (in seconds) and
# we want it to tell us the position of the fired shell
# relative to the Howitzer. We know the parameters, and
# the initial conditions. We need to ask for the time,
# and then calculate and report the position.

from math import cos, sin, radians  # << this imports these functions from Python's math library

### ballistics parameters ###
# v_t = computed earlier
# g = computed earlier
e = 2.718281828  # the exponential constant

### Initial conditions ###
# v_i = computed earlier
theta = radians(37)  # the firing angle -- you choose! ex) radians(37) for 37 degrees

### Elapsed time ###
t = input("Please give a time, in seconds:  ")  # solicit input from the command line
t = float(t)  # make sure this a number (what happens if it isn't?)

# use the trajectory formula to calculate
x_t = (v_t/g) * (v_i * cos(theta)) * (1 - e**(-1*g*t / v_t))
y_t = (v_t/g) * (v_i*sin(theta) + v_t)*(1 - e**(-1*g*t / v_t)) - v_t * t

# print out the position at that time
print(t, x_t, y_t)

#### Are you done early? ####
# Play around with different angles, see how it changes things.
# Try an angle that doesn't make sense. Does the program realize this?
# And finally, what would you like to be able to do to make this program more useful?
